#/bin/bash

# Agenten Plattform
#
# (c) 2024 Magnus Bender
# 	Institute of Humanities-Centered Artificial Intelligence (CHAI)
# 	Universitaet Hamburg
# 	https://www.chai.uni-hamburg.de/~bender
#  
# source code released under the terms of GNU Public License Version 3
# https://www.gnu.org/licenses/gpl-3.0.txt

# https://stackoverflow.com/a/4774063
SCRIPTPATH="$(cd -- "$(dirname "$0")" >/dev/null 2>&1; pwd -P)"

source "$SCRIPTPATH/vars.sh"

day_tag=$(date '+%Y-%m-%d')

images_a=$(docker image ls "$IMAGE_REGISTRY/$IMAGE_OWNER/$IMAGE_NAME_AGENT" --format '{{.Repository}}:{{.Tag}}')
images_b=$(docker image ls "$IMAGE_REGISTRY/$IMAGE_OWNER/$IMAGE_NAME_MGMT" --format '{{.Repository}}:{{.Tag}}')

echo "$images_a\n$images_b" | while read image_url ;
do

	image_name="${image_url##*/}"
	image_name="${image_name%%:*}"
	image_tag="${image_url##*:}"

	if [[ "$image_tag" =~ ^((gpu-)|(cpu-))?((arm64)|(amd64))$ ]]; 
	then

		echo "Push:"
		echo "	$IMAGE_REGISTRY/$IMAGE_OWNER/$image_name:$image_tag"
		echo "	$IMAGE_REGISTRY/$IMAGE_OWNER/$image_name:$image_tag-$day_tag"

		docker push "$IMAGE_REGISTRY/$IMAGE_OWNER/$image_name:$image_tag"

		docker tag "$IMAGE_REGISTRY/$IMAGE_OWNER/$image_name:$image_tag" \
				"$IMAGE_REGISTRY/$IMAGE_OWNER/$image_name:$image_tag-$day_tag"

		docker push "$IMAGE_REGISTRY/$IMAGE_OWNER/$image_name:$image_tag-$day_tag"
	fi;
done